// WScaleBar.h : Declaration of the CWScaleBar

#ifndef __WSCALEBAR_H_
#define __WSCALEBAR_H_
#include "resource.h"       // main symbols
#include <objsafe.h>
#include <atlctl.h>
#include <iostream>
#include <strstream>
#include "util.h"
#include "LocaleEngine.h"

using namespace std;
/////////////////////////////////////////////////////////////////////////////
// CWScaleBar
class ATL_NO_VTABLE CWScaleBar : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CStockPropImpl<CWScaleBar, IWScaleBar, &IID_IWScaleBar, &LIBID_WSCALEBARSERVERLib>,
	public CComControl<CWScaleBar>,
	public IPersistStreamInitImpl<CWScaleBar>,
	public IOleControlImpl<CWScaleBar>,
	public IOleObjectImpl<CWScaleBar>,
	public IOleInPlaceActiveObjectImpl<CWScaleBar>,
	public IViewObjectExImpl<CWScaleBar>,
	public IOleInPlaceObjectWindowlessImpl<CWScaleBar>,
	public IConnectionPointContainerImpl<CWScaleBar>,
	public IPersistStorageImpl<CWScaleBar>,
	public ISpecifyPropertyPagesImpl<CWScaleBar>,
	public IQuickActivateImpl<CWScaleBar>,
	public IDataObjectImpl<CWScaleBar>,
	public IProvideClassInfo2Impl<&CLSID_WScaleBar, &DIID__IWScaleBarEvents, &LIBID_WSCALEBARSERVERLib>,
	public IPropertyNotifySinkCP<CWScaleBar>,
	public CComCoClass<CWScaleBar, &CLSID_WScaleBar>
{
public:
	CWScaleBar();

DECLARE_REGISTRY_RESOURCEID(IDR_WSCALEBAR)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CWScaleBar)
	COM_INTERFACE_ENTRY(IWScaleBar)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(IViewObjectEx)
	COM_INTERFACE_ENTRY(IViewObject2)
	COM_INTERFACE_ENTRY(IViewObject)
	COM_INTERFACE_ENTRY(IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceObject)
	COM_INTERFACE_ENTRY2(IOleWindow, IOleInPlaceObjectWindowless)
	COM_INTERFACE_ENTRY(IOleInPlaceActiveObject)
	COM_INTERFACE_ENTRY(IOleControl)
	COM_INTERFACE_ENTRY(IOleObject)
	COM_INTERFACE_ENTRY(IPersistStreamInit)
	COM_INTERFACE_ENTRY2(IPersist, IPersistStreamInit)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
	COM_INTERFACE_ENTRY(ISpecifyPropertyPages)
	COM_INTERFACE_ENTRY(IQuickActivate)
	COM_INTERFACE_ENTRY(IPersistStorage)
	COM_INTERFACE_ENTRY(IDataObject)
	COM_INTERFACE_ENTRY(IProvideClassInfo)
	COM_INTERFACE_ENTRY(IProvideClassInfo2)
END_COM_MAP()

BEGIN_PROP_MAP(CWScaleBar)
	PROP_DATA_ENTRY("_cx", m_sizeExtent.cx, VT_UI4)
	PROP_DATA_ENTRY("_cy", m_sizeExtent.cy, VT_UI4)
	PROP_ENTRY("BackColor", DISPID_BACKCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("BorderColor", DISPID_BORDERCOLOR, CLSID_StockColorPage)
	PROP_ENTRY("BorderVisible", DISPID_BORDERVISIBLE, CLSID_NULL)
	PROP_ENTRY("BorderWidth", DISPID_BORDERWIDTH, CLSID_NULL)
	PROP_ENTRY("Font", DISPID_FONT, CLSID_StockFontPage)
	PROP_ENTRY("ForeColor", DISPID_FORECOLOR, CLSID_StockColorPage)
	PROP_ENTRY("BarColor1", 1, CLSID_StockColorPage)
	PROP_ENTRY("BarColor2", 2, CLSID_StockColorPage)
	PROP_ENTRY("BarWidth", 3, CLSID_NULL)
	PROP_ENTRY("MapUnit", 5, CLSID_NULL)
	PROP_ENTRY("BarUnit", 6, CLSID_NULL)
	PROP_ENTRY("BarOutline", 7, CLSID_NULL)
	PROP_ENTRY("BarOutlineColor", 8, CLSID_StockColorPage)
	PROP_ENTRY("Scale", 9, CLSID_NULL)
	PROP_ENTRY("NumTics", 14, CLSID_NULL)
	PROP_ENTRY("ScaleText", 15, CLSID_NULL)
	PROP_ENTRY("BarStyle", 16, CLSID_NULL)
	PROP_ENTRY("BorderStyle", 17, CLSID_NULL)
//	PROP_ENTRY("TransparentBG", 18, CLSID_NULL)
//	PROP_ENTRY("FormatNumber", 20, CLSID_NULL)

	// Example entries
	// PROP_ENTRY("Property Description", dispid, clsid)
	// PROP_PAGE(CLSID_StockColorPage)
END_PROP_MAP()

BEGIN_CONNECTION_POINT_MAP(CWScaleBar)
	CONNECTION_POINT_ENTRY(IID_IPropertyNotifySink)
END_CONNECTION_POINT_MAP()

BEGIN_MSG_MAP(CWScaleBar)
	CHAIN_MSG_MAP(CComControl<CWScaleBar>)
	DEFAULT_REFLECTION_HANDLER()
//	MESSAGE_HANDLER(WM_CREATE, OnCreate)
//	MESSAGE_HANDLER(WM_ERASEBKGND, OnEraseBkgnd)
END_MSG_MAP()

BEGIN_CATEGORY_MAP(CWScaleBar)
  IMPLEMENTED_CATEGORY(CATID_SafeForScripting)
  IMPLEMENTED_CATEGORY(CATID_SafeForInitializing)
END_CATEGORY_MAP()
// Handler prototypes:
//  LRESULT MessageHandler(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
//  LRESULT CommandHandler(WORD wNotifyCode, WORD wID, HWND hWndCtl, BOOL& bHandled);
//  LRESULT NotifyHandler(int idCtrl, LPNMHDR pnmh, BOOL& bHandled);


// IViewObjectEx
	DECLARE_VIEW_STATUS(VIEWSTATUS_SOLIDBKGND | VIEWSTATUS_OPAQUE)
//	DECLARE_VIEW_STATUS(0)
// IWScaleBar
public:
	STDMETHOD(RenderOnDC)(/*[in]*/ long hdc, long x1, long y1, long x2, long y2);
	STDMETHOD(get_BarStyle)(/*[out, retval]*/ ScaleBarStyle *pVal);
	STDMETHOD(put_BarStyle)(/*[in]*/ ScaleBarStyle newVal);
	STDMETHOD(get_ScaleText)(/*[out, retval]*/ sbScaleText *pVal);
	STDMETHOD(put_ScaleText)(/*[in]*/ sbScaleText newVal);
	STDMETHOD(get_NumTics)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_NumTics)(/*[in]*/ int newVal);
	STDMETHOD(get_BorderStyle)(/*[out, retval]*/ WSPenStyle *pVal);
	STDMETHOD(put_BorderStyle)(/*[in]*/ WSPenStyle newVal);
//scale-related
	STDMETHOD(SetScaleD)(/*[in]*/ double lon1, /*[in]*/ double lon2, /*[in]*/ double lat, /*[in]*/ long WidthInPixel);
	STDMETHOD(get_Scale)(/*[out, retval]*/ double *pVal);
	STDMETHOD(put_Scale)(/*[in]*/ double newVal);
	STDMETHOD(SetScale)(/*[in]*/ double MapWidth, /*[in]*/ long WidthInPixel);
//unit-related
	STDMETHOD(get_BarUnit)(/*[out, retval]*/ ScaleBarUnits *pVal);
	STDMETHOD(put_BarUnit)(/*[in]*/ ScaleBarUnits newVal);
	STDMETHOD(GetBarUnitInfo)(/*[out]*/ double *factor, /*[out]*/ BSTR * name, /*[out]*/ BSTR *short_name);
	STDMETHOD(GetMapUnitInfo)(/*[out]*/ double *factor, /*[out]*/ BSTR *name, /*[out]*/ BSTR *short_name);
	STDMETHOD(SetCustomUnit)(/*[in]*/ double factor, /*[in]*/ BSTR name, /*[in]*/ BSTR short_name);
	STDMETHOD(get_MapUnit)(/*[out, retval]*/ MapUnits *pVal);
	STDMETHOD(put_MapUnit)(/*[in]*/ MapUnits newVal);

//Interface	
	STDMETHOD(get_BarOutlineColor)(/*[out, retval]*/ OLE_COLOR *pVal);
	STDMETHOD(put_BarOutlineColor)(/*[in]*/ OLE_COLOR newVal);
	STDMETHOD(get_BarOutline)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_BarOutline)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_BarWidth)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_BarWidth)(/*[in]*/ int newVal);
	STDMETHOD(get_BarColor2)(/*[out, retval]*/ OLE_COLOR *pVal);
	STDMETHOD(put_BarColor2)(/*[in]*/ OLE_COLOR newVal);
	STDMETHOD(get_BarColor1)(/*[out, retval]*/ OLE_COLOR *pVal);
	STDMETHOD(put_BarColor1)(/*[in]*/ OLE_COLOR newVal);
	STDMETHOD(AboutBox)();

//Control
//	STDMETHOD(get_TransparentBG)(/*[out, retval]*/ VARIANT_BOOL *pVal);
//	STDMETHOD(put_TransparentBG)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_FormatNumber)(/*[out, retval]*/ VARIANT_BOOL *pVal);
	STDMETHOD(put_FormatNumber)(/*[in]*/ VARIANT_BOOL newVal);
	STDMETHOD(get_MarginRight)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_MarginRight)(/*[in]*/ int newVal);
	STDMETHOD(get_MarginLeft)(/*[out, retval]*/ int *pVal);
	STDMETHOD(put_MarginLeft)(/*[in]*/ int newVal);

	OLE_COLOR m_clrBackColor;
	OLE_COLOR m_clrBorderColor;
	OLE_COLOR m_clrForeColor;
	OLE_COLOR m_clrBarColor1;
	OLE_COLOR m_clrBarColor2;
	WSPenStyle m_nBorderStyle;
	BOOL m_bBorderVisible;
	LONG m_nBorderWidth;
	CComPtr<IFontDisp> m_pFont;
	int m_nBarWidth;
	OLE_COLOR m_clrBarOutline;
	BOOL m_bBarOutline;
private:
//Unit
	ScaleBarUnits m_nBarUnit;
	MapUnits m_nMapUnit;
	char m_strMapUnitShortName[MaxNameLength+1];
	char m_strMapUnitName[MaxNameLength+1];
	char m_strBarUnitShortName[MaxNameLength+1];
	char m_strBarUnitName[MaxNameLength+1];
	double m_fMapUnitFactor;
	double m_fBarUnitFactor;

//scale
	double m_fScale;     //map scale
	double m_fMapWidth;  //the width in map unit
	long   m_nPageWidth; //the width in pixel for the map on screen
	double m_fLon1;      //longitude 1 for map that is lat/lon
	double m_fLon2;      //longitude 2 for map that is lat/lon
	double m_fLat;       //latitude 1 for map that is lat/lon 

//bar
	int    m_nNumTics;   //How many tics on for the scalebar.
	sbScaleText m_sbScaleText;
	ScaleBarStyle m_barStyle;

//Control
	BOOL m_bTransparentBG;
	BOOL m_bFormatNumber; //Format the number using locale and thousand separators.
	int  m_nMarginLeft;   //left margin for the scale bar
	int  m_nMarginRight;  //right margin for the scale bar
private:
	LocaleEngine m_locale;
private:
	void SetTransparentWnd();
	void DrawTheControl(HDC hdc, RECT rc);
    void DrawBar(HDC hdc, int nTicLength, int nOffsetX, int nOffsetY);
    void DrawBackground(HDC hdc, RECT rc);
    void DrawBorder(HDC hdc, RECT rc);
	void DrawTextWithAlign(HDC hdc, char *str, int x, int y, UINT TextAlign);
    void DrawVerbalScale(HDC hdc, int x, int y);
    void DrawSegmentText(HDC hdc, int x, int y, int Tics, int TicWidth, double SBUnitsPerTic, char *str_unit);
	void ScaleBarText(double scale, sbScaleText scale_text, char *buffer, int buffer_size);
	void CalcScale(); 
public:
	LRESULT OnCreate(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled);
	HRESULT OnDraw(ATL_DRAWINFO& di);
/*	LRESULT OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
	{
		// TODO : Add Code for message handler. Call DefWindowProc if necessary.
		bHandled=TRUE;
		return 0;
	}*/
};

#endif //__WSCALEBAR_H_
