#ifndef WSCaleBar_UTIL_H
#define WSCaleBar_UTIL_H

#include <math.h>
const int PowerRangeMin=-5;
const int PowerRangeMax=10;
const int nNiceNumber=4;
const int defaultBarWidth=5;
const double NiceNumberArray[nNiceNumber]={1, 2, 2.5, 5};
const int ScalePrecisionDigits=5;
const int GapScaleText_Bar=3;
const int GapBar_SegmentText=1;

const int defaultMapUnit           =9001; //meter
const int defaultScaleBarUnit      =9001; //meter
const BOOL defaultBorderVisible    =FALSE;
const BOOL defaultBarOutline       =TRUE;
const int defaultBorderWidth       =1;
const int defaultBorderStyle       =PS_SOLID;
const OLE_COLOR defaultBorderColor=0x0;
const OLE_COLOR defaultForeColor   =0x0;
const OLE_COLOR defaultBgColor     =0xffffff;
const OLE_COLOR defaultBarOutlineCr=0x0;
const OLE_COLOR defaultBarColor1   =0xff0000;
const OLE_COLOR defaultBarColor2   =0xffffff;

const double DTR = 0.01745329252; // Convert Degrees to Radians
const double metersPerInch=0.0254; 
const double metersPerMile=1609.347219;
const double milesPerDegreeAtEquator=69.171;
const double metersPerDegreeAtEquator= metersPerMile * milesPerDegreeAtEquator;

const int defaultNumTics=4;
const int defaultMarginX=4;
const double fVerySmall=0.0000001;

const int MaxNameLength=80;
const int UNIT_NUMS=8;
typedef struct {
  int id;
  double factor;
  char name[MaxNameLength+1];
  char short_name[MaxNameLength+1];
} UnitInfo;

//Return how many pixels per inch on the screen.
int PixelsPerInchForScreen();
//Scale functions.
extern double GetRoundIncrement(double StartValue);
extern double CalcRFScale(double widthMap, double widthPage, double MapUnitFactor);
extern double CalcRFScaleD(double lon1, double lon2, double lat, double widthPage);
extern void CalcBarScale(int nWidthDC, int nNumTics, double fMapScale, double fBarUnitFactor, int &PixelsPerTic, double &SBUnitsPerTic);
extern double FormatRealScale(double scale);

//Drawing functions.
extern void DrawRectangle(HDC hdc, RECT r, COLORREF cr=0, int nWidth=1, int penStyle=PS_SOLID);
extern void FillRectangle(HDC hdc, RECT r, int brStyle=BS_SOLID, COLORREF crBrush=0, int penStyle=PS_SOLID, COLORREF crPen=0, int nPenWidth=1);
extern void DrawBarWithStyle(HDC hdc, int nOffsetX, int nOffsetY, int nNumTics, int nTicLength, int nBarWidth=defaultBarWidth, COLORREF crBar1=defaultBarColor1, COLORREF crBar2=defaultBarColor2, BOOL bOutline=defaultBarOutline, COLORREF crOutline=defaultBarOutlineCr, int style=0);
void DrawTicBarStandard(HDC hdc, int nTics, int nWidth, COLORREF crBar1, COLORREF crBar2, int nTicLength, int xOrigin, int yOrigin, BOOL bOutline=defaultBarOutline, COLORREF crOutline=defaultBarOutlineCr);
void DrawTicBarMeridian(HDC hdc, int nTics, int nWidth, COLORREF crBar1, COLORREF crBar2, int nTicLength, int xOrigin, int yOrigin, BOOL bOutline=defaultBarOutline, COLORREF crOutline=defaultBarOutlineCr);
void DrawTicBarMeridian1(HDC hdc, int nTics, int nWidth, COLORREF crBar1, COLORREF crBar2, int nTicLength, int xOrigin, int yOrigin, BOOL bOutline=defaultBarOutline, COLORREF crOutline=defaultBarOutlineCr);
void DrawTicLine(HDC hdc, int nTics, COLORREF crBar1, COLORREF crBar2, int nTicLength, int xOrigin, int yOrigin);

//Distance related functions.
extern double DiffLongitude(double lon1, double lon2);
extern double GC_Range(double lon1, double lat1, double lon2, double lat2);
extern double GC_Range(double lon1, double lmon2, double lat);

//Get the information for the unit
extern void GetUnitInformation(int unit_id, double &factor, char *name, char *short_name);

extern int PresitionOfSegmentText(double value);

#endif